bl_info = {
    "name": "Auto Highlight in Outliner",
    "author": "Amandeep",
    "description": "Automatically highlight selected objects in the outliner",
    "blender": (2, 83, 0),
    "version": (1, 0, 0),
    "location": "",
    "warning": "",
    "category": "Object",
}

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTIBILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

import bpy
from bpy.app.handlers import persistent
def obj(): pass
obj.timer=None
def preferences():
    return bpy.context.preferences.addons[__package__].preferences
class AHPrefs(bpy.types.AddonPreferences):
    bl_idname = __package__
    
    def draw(self, context):
        pass
class AH_PT_AH_Addon(bpy.types.Panel):
    bl_label = "Auto Highlight"
    bl_idname = "OBJECT_PT_AH"
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    bl_category = "View"
    show_create:bpy.props.BoolProperty(default=True)
    def draw(self, context):
        layout= self.layout
        layout.operator('ah.test')
class AH_OT_Test(bpy.types.Operator):
    bl_idname = "ah.startautohighlight"
    bl_label = "Start Auto Highlight"
    bl_description = ""
    bl_options = {"REGISTER"}

    @classmethod
    def poll(cls, context):
        return True
    def modal(self, context,event):
        if event.type == 'TIMER' and context.scene.auto_highlight_in_outliner:
            #print("Hi")
            self.new_selection=set(bpy.context.selected_objects[:])
            if self.new_selection!=self.prev_selection:
                self.prev_selection=self.new_selection
                override = None

                for area in context.screen.areas:
                    if 'OUTLINER' in area.type:
                        for region in area.regions:
                            if 'WINDOW' in region.type:
                                override = {'area': area, 'region': region}
                                break
                        break
                if override is not None:
                    bpy.ops.outliner.show_active(override)
                #context.area.tag_redraw()
        return {'PASS_THROUGH'}
    def execute(self, context):
        wm=context.window_manager
        obj.timer=self.timer = wm.event_timer_add(0.05,window= context.window)
        wm.modal_handler_add(self)
        self.new_selection=set(bpy.context.selected_objects[:])
        self.prev_selection=set([])
        return {"RUNNING_MODAL"}


#     #print(points)
# new_active = None
# prev_active = None
# new_selection, prev_selection=None,None

# def draw_hotkeys(scene):
#     global new_active, prev_active,prev_selection,new_selection
#     return

    
#     new_selection_mode=""
#     count=0
#     active=bpy.context.active_object
#     count=len(bpy.context.selected_objects)
#     new_selection=set(bpy.context.selected_objects[:])
#     new_active=active
#     if new_active!=prev_active:
#         print("Changed:",new_active)
#         prev_active=new_active
#     if prev_selection!=new_selection:
#         bpy.ops.ah.test('INVOKE_DEFAULT')
#         prev_selection=new_selection
                
    

classes = (AHPrefs,AH_OT_Test
)

icon_collection={}
addon_keymaps = []

def drawIntoOutliner(self, context):
    layout= self.layout
    layout.separator(factor=1)
    row=layout.row()
    row.prop(context.scene,'auto_highlight_in_outliner')

def register():
    from bpy.utils import register_class
    for cls in classes:
        register_class(cls)
    
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    kmaps = [
    ]
    
    km = kc.keymaps.new(name="3D View", space_type="VIEW_3D")
    if kc:
        for (op, k, sp) in kmaps:

            kmi = km.keymap_items.new(
                op,
                type=k,
                value="PRESS",
                alt="alt" in sp,
                shift="shift" in sp,
                ctrl="ctrl" in sp,
            )
            addon_keymaps.append((km, kmi))
    bpy.types.OUTLINER_PT_filter.append(drawIntoOutliner)
    bpy.types.Scene.auto_highlight_in_outliner= bpy.props.BoolProperty(default=False,name="Auto Highlight")
    bpy.app.handlers.load_post.append(start_ah)
    bpy.app.handlers.load_pre.append(stop_modal)
from bpy.app.handlers import persistent
@persistent
def stop_modal(scene):
    if obj.timer:
        bpy.context.window_manager.event_timer_remove(obj.timer)
        obj.timer=None
@persistent
def start_ah(scene):
    bpy.ops.ah.startautohighlight('INVOKE_DEFAULT')

def unregister():
    if obj.timer:
        bpy.context.window_manager.event_timer_remove(obj.timer)
        obj.timer=None
    from bpy.utils import unregister_class

    for cls in reversed(classes):
        unregister_class(cls)
    for (km, kmi) in addon_keymaps:
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    bpy.types.OUTLINER_PT_filter.remove(drawIntoOutliner)
    bpy.app.handlers.load_post.clear()
    bpy.app.handlers.load_pre.clear()
if __name__ == "__main__":
    register()

